#ifndef FRONT_NONDETERMINISTIC_H
#define FRONT_NONDETERMINISTIC_H

#include <iostream>

#include "ir2monitor.h"

namespace mm {
  namespace ir_visitors {
/**
 * 
 */
class front_nondeterministic_visitor : public mm::ir_visitors::ir2monitor {

 public:
  // Constructor
  front_nondeterministic_visitor(global_params*, monitor_params*, std::ostream&, std::ostream&);
  // Destructor
  virtual ~front_nondeterministic_visitor();
  
  virtual void begin(intermediate_rep* automaton);
  virtual void process_state(state_t* state);
  virtual void process_outgoing(transition_t* trans);
  virtual void process_incoming(transition_t* trans);
  virtual void end();

 protected:
  void step_footer();
  
 private:
  bool outer_if_closing_brace_needed;
  int accept_all_state_index;
};

  } // namespace ir_visitors
} // namespace mm

#endif
